print macro string
lea dx,string
mov ah,9
int 21h
endm
;
; this is a skeleton for passthrough  or resident programs
;
; when compiled as a pass through program it will use a little over
; 5K of system memory. When compiled as resident program it takes
; about 1.5k. When you add your own routines an work areas this
; will increase.
;
passthru = 1  ; 1 is true which means MASM will create the passthroug
              ; version.
; if you are making a passthroug version then rou are not making
; a resident version. And if you are not making a passthrough then
; you are making a resident.
;
if passthru
   resident = 0
else
   resident = 1
endif
CSEG        SEGMENT PARA PUBLIC 'CODE'
        ASSUME CS:CSEG,DS:CSEG,SS:CSEG,ES:CSEG
        ORG        100H
ENTPT:        JMP        setpass
; this area is used by the resident and passthrough versions
;
istack  dw 256 dup(0)
savesp   dw  0
savess   dw  0
savespl  dw  0
savessl  dw  0
semaphore db  0
cursor    dw  0
cursmode  dw  0
bhpage    db  0
cntmax    dw  0
timecx    dw  0
timedx    dw  0
timecl    db  0
timech    db  0
timedl    db  0
timedh    db  0
mess10    db    13,10,'Total elapsed time: $'
dot       db    '.$'
colon     db    ':$'
tenw      dw    10
sixty_four    dw    64
hundred   dw    100
p_decimal db    '00000$'
crlf     db 13,10,'$'
;
; this data is used by the passthru program only
;
if passthru
command_line db 129 dup(0)
; parmblock is used for the parmeters for the execute
parmblock  dw  0  ; this is the parmblock for execute
           dw command_line
tailds     dw  0
           dw 5ch ; fcb in psp
fcb1       dw  0
           dw 6ch ; fcb in psp
fcb2       dw  0
endif
; the tone routines produce glisandos based on the value of si
blip    proc  near
        push  si
        mov   si,30
        call  tone
        pop   si
        ret
blip    endp
blop    proc  near
        push  si
        mov   si,-30
        call  tone
        pop   si
        ret
blop    endp
tone    proc  near
        push  ax
        push  bx
        push  cx
        push  dx
        mov   dx,3    ; tone rate
        mov   bx,240  ; starting freq
        mov   cx,750  ; ending frequency
        cmp   si,0
        jg    do_blip
; here we do blop
        mov   bx,630  ; starting freq
        mov   cx,150  ; ending frequency
do_blip:
; turn on tone
i0:
        push  cx
        push  bx
        in     al,61h
        or     al,3
        out    61h,al
; loop parameters
        mov    cx,bx
 ; set frequency
        mov    dx,12h
        mov    ax,34deh
        div    cx
        mov    cx,ax
; set tone
        mov    al,cl
        out    42h,al
        mov    al,ch
        out    42h,al
i2:     loop i2
        pop    bx
        pop    cx
        cmp    bx,cx
        je     ip3
        add    bx,si
        jmp    i0
ip3:
 ;turn off tone
        in  al,61h
        and al,11111100b
        out 61h,al
        pop  dx
        pop  cx
        pop  bx
        pop  ax
        ret
tone    endp
dodecimal proc  near
; this procedure has a number in ax that is 0 to 32000
; it converts it to decimal and then prints it
          push ax
          push bx
          push cx
          push dx
          push si
          push di
          push ds
          push es
; here goes the code
          push ax
          mov  ax,cs
          mov  ds,ax
          mov  es,ax
          cld
          lea  di,p_decimal
          mov  ax,'00'
          stosw
          stosw
          stosb
          mov  dx,0
          mov  cx,0
          mov  bx,0
          pop  ax
          cmp   ax,0
          je   do_space
          div  hundred
; dx has the hundreds remainder
          mov  cx,dx   ; save dx
          cmp  ax,0
          je   do_dx
          mov  dx,0
          div  tenw
          add  dx,30h
          mov  p_decimal+2,dl
          cmp  ax,0
          je   do_dx
          mov  dx,0
          div  tenw
          add  dx,30h
          mov  p_decimal+1,dl
          add  ax,30h
          mov  p_decimal,al
do_dx:
          cmp  dx,0
          je   do_space
          mov  ax,dx
          mov  dx,0
          div  tenw
          add  dx,30h
          add  ax,30h
          mov  p_decimal+4,dl
          mov  p_decimal+3,al
do_space:
          lea  di,p_decimal
          mov  si,di
          mov  cx,4
spaceloop:
          cld
          lodsb
          cmp  al,'0'
          jne  exit_decimal
          mov  al,' '
          stosb
          loop  spaceloop
exit_decimal:
          lea  di,p_decimal
          mov  cx,6
          cld
          mov  al,20h
repe      scasb
          dec  di
          mov  bx,di
          print [bx]
          pop  es
          pop  ds
          pop  di
          pop  si
          pop  dx
          pop  cx
          pop  bx
          pop  ax
          ret
dodecimal endp
gettime proc near
; get the time
          mov   ah,2ch
          int   21h
          mov   timecx,cx
          mov   timedx,dx
          ret
gettime endp
do_end_time proc near
          print mess10
          mov   ah,2ch
          int   21h
          push  cx
          push  dx
          mov   bx,0
          mov   dh,0
          mov   ax,timedx
          mov   ah,0
          sub   dx,ax
          mov   timedl,dl
          cmp   dx,0
          jge   do_dh
          add   dx,100
          mov   timedl,dl
          mov   bx,1
do_dh:
          pop   dx
          mov   dl,dh
          mov   dh,0
          mov   ax,timedx
          mov   al,ah
          mov   ah,0
          sub   dx,ax
          sub   dx,bx
          mov   bx,0
          mov   timedh,dl
          cmp   dl,0
          jge   do_cl
          add   dl,60
          mov   timedh,dl
          mov   bx,1
do_cl:
          pop   dx
          push  dx
          mov   dh,0
          mov   ax,timecx
          mov   ah,0
          sub   dx,ax
          sub   dx,bx
          mov   bx,0
          mov   timecl,dl
          cmp   dl,0
          jge   do_ch
          add   dl,60
          mov   timecl,dl
          mov   bx,1
do_ch:
          pop   dx
          mov   dl,dh
          mov   dh,0
          mov   ax,timecx
          mov   al,ah
          mov   ah,0
          sub   dx,ax
          sub   dx,bx
          mov   bx,0
          mov   timech,dl
          cmp   dl,0
          jge   do_rest
          add   dl,24
          mov   timech,dl
do_rest:
          mov   cl,timecl
          mov   ch,timech
          mov   dl,timedl
          mov   dh,timedh
; do the print time dx, and cx have the time
          push  dx
          push  cx
          mov   al,ch
          mov   ah,0
          call  dodecimal
          print colon
          pop   cx
          mov   al,cl
          mov   ah,0
          call  dodecimal
          print colon
          pop   cx
          push  cx
          mov   al,ch
          mov   ah,0
          call  dodecimal
          print dot
          pop   cx
          mov   al,cl
          mov   ah,0
          call  dodecimal
          print crlf
          call  blip
          ret
do_end_time endp
setpass  proc  near
; set up a local istack
        lea  sp,istack+510
        call  gettime
if  passthru
;
;  prepare for the exec function
; shrink memory
   lea   bx,last_byte    ; last byte of program
   add   bx,15           ; trick to round up
   mov   cl,4
   shr   bx,cl           ; divide by 16 to get number of 16 byte blocks
   mov   ah,4ah          ; shrink
   int   21h
; create the commandline
;
; the command line has to start with /C and then the command
; and then end with a carriage return. It must have a byte at
; the front saying how long it is
   cld
   lea   di,command_line+1
   mov   al,'/'
   stosb
   mov   al,'C'
   stosb
   mov   al,' '
   stosb
; now copy the real command line in
   mov   si,81h
   mov   cl,byte ptr ds:[80h]
   mov   ch,0
   push  cx
   cmp   cx,0
   je    no_move
   cld
rep movsb
no_move:
   pop   cx
   add   cx,3
   mov   command_line,cl
; set up the control block with segment information
   mov    tailds,ds
   mov    fcb1,ds
   mov    fcb2,ds
;
; find the comspec
;
   mov    es,word ptr  ds:[2ch]
   mov     di,0
   mov     cx,255
env_loop:
   cld
   mov   al,'='
repne   scasb
; if there is no comspec, there is something wrong with the system
   cmp   word ptr es:[di-3],'CE'
   jne   env_loop
   cmp   word ptr es:[di-5],'PS'
   jne   env_loop
   cmp   word ptr es:[di-7],'MO'
   jne   env_loop
   cmp   byte ptr es:[di-8],'C'
   jne   env_loop
; got the comspec
;
; save the istack
;
   mov   savess,ss
   mov   savesp,sp
;
; set up the segment registers
;
; the comspec segment is in ES and should be in DS
;
   push  es
   pop   ds
   push  cs
   pop   es
   mov   dx,di
   lea   bx,parmblock
   mov   al,0
   mov   ah,4bh
; execute the thing
   int   21h
; here is where we return
   mov   ss,cs:savess
   mov   sp,cs:savesp
   mov   ax,cs
   mov   ds,ax
   mov   es,ax
; say that we did it
   call  do_end_time
        int   20h
endif
if resident
        lea   dx,setpass  ; don't make the install portion resident
        int 27h
endif
setpass  endp
last_byte equ this byte
CSEG        ENDS
        END        ENTPT
